Package org.apache.storm.testing

# Class FixedTupleSpout

java.lang.Object
org.apache.storm.testing.FixedTupleSpout

All Implemented Interfaces:
  `Serializable`, `ISpout`, `CompletableSpout`, `IComponent`, `IRichSpout`

public class FixedTupleSpout extends Object implements IRichSpout, CompletableSpout

See Also:
  - Serialized Form

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `FixedTupleSpout(List tuples)`
  `FixedTupleSpout(List tuples, Fields fields)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `ack(Object msgId)`
  Storm has determined that the tuple emitted by this spout with the msgId identifier has been fully processed.
  `void`
  `activate()`
  Called when a spout has been activated out of a deactivated mode.
  `void`
  `cleanup()`
  `static void`
  `clear(String stormId)`
  `void`
  `close()`
  Called when an ISpout is going to be shutdown.
  `void`
  `deactivate()`
  Called when a spout has been deactivated.
  `void`
  `declareOutputFields(OutputFieldsDeclarer declarer)`
  Declare the output schema for all the streams of this topology.
  `void`
  `fail(Object msgId)`
  The tuple emitted by this spout with the msgId identifier has failed to be fully processed.
  `int`
  `getCompleted()`
  `Map<String,Object>`
  `getComponentConfiguration()`
  Declare configuration specific to this component.
  `static int`
  `getNumAcked(String stormId)`
  `static int`
  `getNumFailed(String stormId)`
  `List<FixedTuple>`
  `getSourceTuples()`
  `boolean`
  `isExhausted()`
  Check whether spout is exhausted.
  `void`
  `nextTuple()`
  When this method is called, Storm is requesting that the Spout emit tuples to the output collector.
  `void`
  `open(Map<String,Object> conf, TopologyContext context, SpoutOutputCollector collector)`
  Called when a task for this component is initialized within a worker on the cluster.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

  ### Methods inherited from interface org.apache.storm.testing.CompletableSpout

  `clean, startup`

- ## Constructor Details

  - ### FixedTupleSpout

    public FixedTupleSpout(List tuples)

  - ### FixedTupleSpout

    public FixedTupleSpout(List tuples, Fields fields)

- ## Method Details

  - ### getNumAcked

    public static int getNumAcked(String stormId)

  - ### getNumFailed

    public static int getNumFailed(String stormId)

  - ### clear

    public static void clear(String stormId)

  - ### getSourceTuples

    public List<FixedTuple> getSourceTuples()

  - ### getCompleted

    public int getCompleted()

  - ### cleanup

    public void cleanup()

  - ### open

    public void open(Map<String,Object> conf, TopologyContext context, SpoutOutputCollector collector)
    Description copied from interface: `ISpout`
    Called when a task for this component is initialized within a worker on the cluster. It provides the spout with the environment in which the spout executes.

    This includes the:

    Specified by:
      `open` in interface `ISpout`
    Parameters:
      `conf` - The Storm configuration for this spout. This is the configuration provided to the topology merged in with cluster configuration on this machine.
      `context` - This object can be used to get information about this task's place within the topology, including the task id and component id of this task, input and output information, etc.
      `collector` - The collector is used to emit tuples from this spout. Tuples can be emitted at any time, including the open and close methods. The collector is thread-safe and should be saved as an instance variable of this spout object.

  - ### close

    public void close()
    Description copied from interface: `ISpout`
    Called when an ISpout is going to be shutdown. There is no guarentee that close will be called, because the supervisor kill -9's worker processes on the cluster.

    The one context where close is guaranteed to be called is a topology is killed when running Storm in local mode.

    Specified by:
      `close` in interface `ISpout`

  - ### nextTuple

    public void nextTuple()
    Description copied from interface: `ISpout`
    When this method is called, Storm is requesting that the Spout emit tuples to the output collector. This method should be non-blocking, so if the Spout has no tuples to emit, this method should return. nextTuple, ack, and fail are all called in a tight loop in a single thread in the spout task. When there are no tuples to emit, it is courteous to have nextTuple sleep for a short amount of time (like a single millisecond) so as not to waste too much CPU.
    Specified by:
      `nextTuple` in interface `ISpout`

  - ### ack

    public void ack(Object msgId)
    Description copied from interface: `ISpout`
    Storm has determined that the tuple emitted by this spout with the msgId identifier has been fully processed. Typically, an implementation of this method will take that message off the queue and prevent it from being replayed.
    Specified by:
      `ack` in interface `ISpout`

  - ### fail

    public void fail(Object msgId)
    Description copied from interface: `ISpout`
    The tuple emitted by this spout with the msgId identifier has failed to be fully processed. Typically, an implementation of this method will put that message back on the queue to be replayed at a later time.
    Specified by:
      `fail` in interface `ISpout`

  - ### activate

    public void activate()
    Description copied from interface: `ISpout`
    Called when a spout has been activated out of a deactivated mode. nextTuple will be called on this spout soon. A spout can become activated after having been deactivated when the topology is manipulated using the `storm` client.
    Specified by:
      `activate` in interface `ISpout`

  - ### deactivate

    public void deactivate()
    Description copied from interface: `ISpout`
    Called when a spout has been deactivated. nextTuple will not be called while a spout is deactivated. The spout may or may not be reactivated in the future.
    Specified by:
      `deactivate` in interface `ISpout`

  - ### declareOutputFields

    public void declareOutputFields(OutputFieldsDeclarer declarer)
    Description copied from interface: `IComponent`
    Declare the output schema for all the streams of this topology.
    Specified by:
      `declareOutputFields` in interface `IComponent`
    Parameters:
      `declarer` - this is used to declare output stream ids, output fields, and whether or not each output stream is a direct stream

  - ### getComponentConfiguration

    public Map<String,Object> getComponentConfiguration()
    Description copied from interface: `IComponent`
    Declare configuration specific to this component. Only a subset of the "topology.*" configs can be overridden. The component configuration can be further overridden when constructing the topology using `TopologyBuilder`
    Specified by:
      `getComponentConfiguration` in interface `IComponent`

  - ### isExhausted

    public boolean isExhausted()
    Description copied from interface: `CompletableSpout`
    Check whether spout is exhausted.
    Specified by:
      `isExhausted` in interface `CompletableSpout`
    Returns:
      true if all the tuples have been completed else false.